<%- include("partials/header") %>
    <!-- REQUESTS Modal -->
    <div class="modal fade" id="requestsShowAllModal" tabindex="-1" role="dialog" aria-labelledby="requestsShowAllModalLabel" aria-hidden="true">
      <div class="modal-dialog modal-xl" role="document">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="requestsShowAllModalLabel">درخواست‌ها</h5>
            <button type="button" class="close mr-auto ml-0" data-dismiss="modal" aria-label="Close">
              <span aria-hidden="true">&times;</span>
            </button>
          </div>
          <div class="modal-body">
            <div class="row m-0">
              <% for (i = 0; i < pageData.requests.length; i++) { %>
                <div class="card ml-auto my-2 w-25 p-2 p-3 col-3 custom-border" reserveid="<%= pageData.requests[i].reserve_data.reserve_id %>">
                  <img src="<%= pageData.requests[i].house_data.pics[0] %>" class="card-img-top" alt="...">
                  <div class="card-body text-right">
                    <p class="mb-2 text-muted small"><span><%= pageData.requests[i].house_data.building_kind %></span> - <span><%= pageData.requests[i].house_data.bedrooms %> خوابه</span> - <span><%= pageData.requests[i].house_data.region %></span>، <span><%= pageData.requests[i].house_data.city %></span></p>
                    <h5 class="mb-2"><%= pageData.requests[i].house_data.title %></h5>
                    <p class="mb-2">تاریخ رفت: <span><%= pageData.requests[i].reserve_data.reserve_from_date_day %></span> <span><%= pageData.requests[i].reserve_data.reserve_from_date_month %></span> <span><%= pageData.requests[i].reserve_data.reserve_from_date_year %></span></p>
                    <p class="mb-2">تاریخ برگشت: <span><%= pageData.requests[i].reserve_data.reserve_to_date_day %></span> <span><%= pageData.requests[i].reserve_data.reserve_to_date_month %></span> <span><%= pageData.requests[i].reserve_data.reserve_to_date_year %></span></p>
                    <p class="mb-2">مبلغ: <span><%= pageData.requests[i].reserve_data.price %></span> ریال</p>
                    <p class="mb-2">وضعیت: <span class="request-status"><%= pageData.requests[i].reserve_data.status %></span></p>
                    <% if (pageData.requests[i].reserve_data.status != "declined") { %>
                      <a href="#" class="send-message-to-guest" onclick="openChatModal(event, <%= pageData.requests[i].reserve_data.guest_id %>);">ارسال پیام به میهمان</a>
                    <% } %>
                    <br>
                    <% if (pageData.requests[i].reserve_data.status == "waiting") { %>
                      <a href="#" class="btn btn-success mt-3" onclick="handleRequest(event, <%= pageData.requests[i].reserve_data.reserve_id %>, 'accept');">تایید درخواست</a>
                      <a href="#" class="btn btn-danger mt-3" onclick="handleRequest(event, <%= pageData.requests[i].reserve_data.reserve_id %>, 'decline');">رد درخواست</a>
                    <% } %>
                  </div>
                </div>
              <% } %>
            </div>
          </div>
        </div>
      </div>
    </div>

    <!-- GUESTS Modal -->
    <div class="modal fade" id="guestsShowAllModal" tabindex="-1" role="dialog" aria-labelledby="guestsShowAllModalLabel" aria-hidden="true">
      <div class="modal-dialog modal-xl" role="document">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="guestsShowAllModalLabel">میهمان‌های شما</h5>
            <button type="button" class="close mr-auto ml-0" data-dismiss="modal" aria-label="Close">
              <span aria-hidden="true">&times;</span>
            </button>
          </div>
          <div class="modal-body">
            <% for (i = 0; i < pageData.guests.length; i++) { %>
              <div class="card ml-auto my-2 w-25 p-2 p-3 col-3 custom-border">
                <img src="<%= pageData.guests[i].house_data.pics[0] %>" class="card-img-top" alt="...">
                <div class="card-body text-right">
                  <p class="mb-2 text-muted small"><span><%= pageData.guests[i].house_data.building_kind %></span> - <span><%= pageData.guests[i].house_data.bedrooms %> خوابه</span> - <span><%= pageData.guests[i].house_data.region %></span>، <span><%= pageData.guests[i].house_data.city %></span></p>
                  <h5 class="mb-2"><%= pageData.guests[i].house_data.title %></h5>
                  <p class="mb-2">تاریخ رفت: <span><%= pageData.guests[i].reserve_data.reserve_from_date_day %></span> <span><%= pageData.guests[i].reserve_data.reserve_from_date_month %></span> <span><%= pageData.guests[i].reserve_data.reserve_from_date_year %></span></p>
                  <p class="mb-2">تاریخ برگشت: <span><%= pageData.guests[i].reserve_data.reserve_to_date_day %></span> <span><%= pageData.guests[i].reserve_data.reserve_to_date_month %></span> <span><%= pageData.guests[i].reserve_data.reserve_to_date_year %></span></p>
                  <p class="mb-2">مبلغ: <span><%= pageData.guests[i].reserve_data.price %></span> ریال</p>
                  <p class="mb-2">وضعیت: <span><%= pageData.guests[i].reserve_data.status %></span></p>
                  <a href="#" class="send-message-to-guest" onclick="openChatModal(event, <%= pageData.guests[i].reserve_data.guest_id %>);">ارسال پیام به میهمان</a>
                </div>
              </div>
            <% } %>
          </div>
        </div>
      </div>
    </div>

    <!-- GUEST HISTORY Modal -->
    <div class="modal fade" id="guestsHistoryShowAllModal" tabindex="-1" role="dialog" aria-labelledby="guestsHistoryShowAllModalLabel" aria-hidden="true">
      <div class="modal-dialog modal-xl" role="document">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="guestsHistoryShowAllModalLabel">میهمان‌های شما</h5>
            <button type="button" class="close mr-auto ml-0" data-dismiss="modal" aria-label="Close">
              <span aria-hidden="true">&times;</span>
            </button>
          </div>
          <div class="modal-body">
            <div class="row m-0">
              <% for (i = 0; i < pageData.houses.length; i++) { %>
                <div class="card ml-auto my-2 w-25 p-2 p-3 col-3 custom-border">
                  <img src="<%= pageData.houses[i].pics[0] %>" class="card-img-top" alt="...">
                  <div class="card-body text-right pt-2">
                    <p class="mb-2 text-muted small"><span><%= pageData.houses[i].building_kind %></span> - <span><%= pageData.houses[i].bedrooms %> خوابه</span> - <span><%= pageData.houses[i].region %></span>، <span><%= pageData.houses[i].city %></span></p>
                    <h5 class="mb-2"><%= pageData.houses[i].title %></h5>
                    <p class="mb-2">قیمت روزانه: <span><%= pageData.houses[i].normal_price %></span> ریال</p>
                    <p class="mb-2">امتیاز:
                      <span rating="<%= pageData.houses[i].rating %>">
                        <i class="fas fa-star"></i>
                        <i class="fas fa-star"></i>
                        <i class="fas fa-star"></i>
                        <i class="fas fa-star"></i>
                        <i class="fas fa-star"></i>
                      </span>
                    </p>
                    <div class="activate-house-control">
                      <div class="custom-control custom-switch">
                        <% if (pageData.houses[i].active == "true") { %>
                          <input type="checkbox" class="custom-control-input" id="<% pageData.houses[i].house_id %>" checked>
                          <label class="custom-control-label" for="<% pageData.houses[i].house_id %>" onclick="handleActivation(event, <%= pageData.houses[i].house_id %>);">وضعیت: <span class="house-status">فعال</span></label>
                        <% } else { %>
                          <input type="checkbox" class="custom-control-input" id="<% pageData.houses[i].house_id %>">
                          <label class="custom-control-label" for="<% pageData.houses[i].house_id %>" onclick="handleActivation(event, <%= pageData.houses[i].house_id %>);">وضعیت: <span class="house-status">غیرفعال</span></label>
                        <% } %>
                      </div>
                    </div>
                  </div>
                </div>
              <% } %>
            </div>
          </div>
        </div>
      </div>
    </div>

    <!-- CHAT Modal -->
    <div class="modal fade" id="chatModal" tabindex="-1" role="dialog" aria-labelledby="chatModalLabel" aria-hidden="true">
      <div class="modal-dialog modal-lg" role="document">
        <div class="modal-content">
          <div class="modal-header">
            <div class="modal-title chat-modal-title" id="chatModalLabel">
              <img src="" class="d-inline-block rounded-circle">
              <h5 class="d-inline-block mb-0 mx-2"></h5>
            </div>
            <button type="button" class="close mr-auto ml-0" data-dismiss="modal" aria-label="Close">
              <span aria-hidden="true">&times;</span>
            </button>
          </div>
          <div class="modal-body p-0">
            <div class="chat-history p-3"></div>
            <form class="chat-form p-3" onsubmit="sendMessage(event);" dir="ltr">
              <div class="input-group">
                <div class="input-group-append">
                  <div class="input-group-text border-0">
                    <button type="submit" class="send-message-button border-0">
                      <i class="fas fa-paper-plane"></i>
                    </button>
                  </div>
                </div>
                <input type="text" class="form-control chat-input text-right" placeholder="پیام" dir="rtl">
              </div>
            </form>
          </div>
        </div>
      </div>
    </div>

    <section class="host-dashboard py-4 px-4">
      <div class="requests-panel my-3">
        <div class="dashboard-panel-title pb-2 pt-1 px-2">
          <h5 class="text-right m-0 float-right">درخواست‌ها <span>(<%= pageData.requests.length %>)</span></h5>
          <a href="#" class="float-left show-all-link" data-toggle="modal" data-target="#requestsShowAllModal">مشاهده‌ی همه <i class="fas fa-chevron-left"></i></a>
          <div class="clearfix"></div>
        </div>
        <div class="dashboard-panel-content p-2">
          <div class="row m-0">
            <% for (i = 0; i < pageData.requests.length; i++) { %>
              <div class="card ml-auto my-2 w-25 p-2 p-3 col-3 custom-border" reserveid="<%= pageData.requests[i].reserve_data.reserve_id %>">
                <img src="<%= pageData.requests[i].house_data.pics[0] %>" class="card-img-top" alt="...">
                <div class="card-body text-right">
                  <p class="mb-2 text-muted small"><span><%= pageData.requests[i].house_data.building_kind %></span> - <span><%= pageData.requests[i].house_data.bedrooms %> خوابه</span> - <span><%= pageData.requests[i].house_data.region %></span>، <span><%= pageData.requests[i].house_data.city %></span></p>
                  <h5 class="mb-2"><%= pageData.requests[i].house_data.title %></h5>
                  <p class="mb-2">تاریخ رفت: <span><%= pageData.requests[i].reserve_data.reserve_from_date_day %></span> <span><%= pageData.requests[i].reserve_data.reserve_from_date_month %></span> <span><%= pageData.requests[i].reserve_data.reserve_from_date_year %></span></p>
                  <p class="mb-2">تاریخ برگشت: <span><%= pageData.requests[i].reserve_data.reserve_to_date_day %></span> <span><%= pageData.requests[i].reserve_data.reserve_to_date_month %></span> <span><%= pageData.requests[i].reserve_data.reserve_to_date_year %></span></p>
                  <p class="mb-2">مبلغ: <span><%= pageData.requests[i].reserve_data.price %></span> ریال</p>
                  <p class="mb-2">وضعیت: <span class="request-status"><%= pageData.requests[i].reserve_data.status %></span></p>
                  <% if (pageData.requests[i].reserve_data.status != "declined") { %>
                    <a href="#" class="send-message-to-guest" onclick="openChatModal(event, <%= pageData.requests[i].reserve_data.guest_id %>);">ارسال پیام به میهمان</a>
                  <% } %>
                  <br>
                  <% if (pageData.requests[i].reserve_data.status == "waiting") { %>
                    <a href="#" class="btn btn-success mt-3" onclick="handleRequest(event, <%= pageData.requests[i].reserve_data.reserve_id %>, 'accept');">تایید درخواست</a>
                    <a href="#" class="btn btn-danger mt-3" onclick="handleRequest(event, <%= pageData.requests[i].reserve_data.reserve_id %>, 'decline');">رد درخواست</a>
                  <% } %>
                </div>
              </div>
            <% } %>
          </div>
        </div>
      </div>
      <div class="guests-panel my-3">
        <div class="dashboard-panel-title pb-2 pt-1 px-2">
          <h5 class="text-right m-0 float-right">میهمان‌ها <span>(<%= pageData.guests.length %>)</span></h5>
          <a href="#" class="float-left show-all-link" data-toggle="modal" data-target="#guestsShowAllModal">مشاهده‌ی همه <i class="fas fa-chevron-left"></i></a>
          <div class="clearfix"></div>
        </div>
        <div class="dashboard-panel-content p-2">
          <div class="row m-0">
            <% for (i = 0; i < pageData.guests.length; i++) { %>
              <div class="card ml-auto my-2 w-25 p-2 p-3 col-3 custom-border">
                <img src="<%= pageData.guests[i].house_data.pics[0] %>" class="card-img-top" alt="...">
                <div class="card-body text-right">
                  <p class="mb-2 text-muted small"><span><%= pageData.guests[i].house_data.building_kind %></span> - <span><%= pageData.guests[i].house_data.bedrooms %> خوابه</span> - <span><%= pageData.guests[i].house_data.region %></span>، <span><%= pageData.guests[i].house_data.city %></span></p>
                  <h5 class="mb-2"><%= pageData.guests[i].house_data.title %></h5>
                  <p class="mb-2">تاریخ رفت: <span><%= pageData.guests[i].reserve_data.reserve_from_date_day %></span> <span><%= pageData.guests[i].reserve_data.reserve_from_date_month %></span> <span><%= pageData.guests[i].reserve_data.reserve_from_date_year %></span></p>
                  <p class="mb-2">تاریخ برگشت: <span><%= pageData.guests[i].reserve_data.reserve_to_date_day %></span> <span><%= pageData.guests[i].reserve_data.reserve_to_date_month %></span> <span><%= pageData.guests[i].reserve_data.reserve_to_date_year %></span></p>
                  <p class="mb-2">مبلغ: <span><%= pageData.guests[i].reserve_data.price %></span> ریال</p>
                  <p class="mb-2">وضعیت: <span><%= pageData.guests[i].reserve_data.status %></span></p>
                  <a href="#" class="send-message-to-guest" onclick="openChatModal(event, <%= pageData.guests[i].reserve_data.guest_id %>);">ارسال پیام به میهمان</a>
                </div>
              </div>
            <% } %>
          </div>
        </div>
      </div>
      <div class="registered-houses-panel my-3">
        <div class="dashboard-panel-title pb-2 pt-1 px-2">
          <h5 class="text-right m-0 float-right">خانه‌های ثبت شده <span>(<%= pageData.houses.length %>)</span></h5>
          <a href="#" class="float-left show-all-link" data-toggle="modal" data-target="#guestsHistoryShowAllModal">مشاهده‌ی همه <i class="fas fa-chevron-left"></i></a>
          <div class="clearfix"></div>
        </div>
        <div class="dashboard-panel-content p-2">
          <div class="row m-0">
            <% for (i = 0; i < pageData.houses.length; i++) { %>
              <div class="card ml-auto my-2 w-25 p-2 p-3 col-3 custom-border">
                <img src="<%= pageData.houses[i].pics[0] %>" class="card-img-top" alt="...">
                <div class="card-body text-right pt-2">
                  <p class="mb-2 text-muted small"><span><%= pageData.houses[i].building_kind %></span> - <span><%= pageData.houses[i].bedrooms %> خوابه</span> - <span><%= pageData.houses[i].region %></span>، <span><%= pageData.houses[i].city %></span></p>
                  <h5 class="mb-2"><%= pageData.houses[i].title %></h5>
                  <p class="mb-2">قیمت روزانه: <span><%= pageData.houses[i].normal_price %></span> ریال</p>
                  <p class="mb-2">امتیاز:
                    <span rating="<%= pageData.houses[i].rating %>">
                      <i class="fas fa-star"></i>
                      <i class="fas fa-star"></i>
                      <i class="fas fa-star"></i>
                      <i class="fas fa-star"></i>
                      <i class="fas fa-star"></i>
                    </span>
                  </p>
                  <div class="activate-house-control">
                    <div class="custom-control custom-switch">
                      <% if (pageData.houses[i].active == "true") { %>
                        <input type="checkbox" class="custom-control-input" id="<% pageData.houses[i].house_id %>" checked>
                        <label class="custom-control-label" for="<% pageData.houses[i].house_id %>" onclick="handleActivation(event, <%= pageData.houses[i].house_id %>);">وضعیت: <span class="house-status">فعال</span></label>
                      <% } else { %>
                        <input type="checkbox" class="custom-control-input" id="<% pageData.houses[i].house_id %>">
                        <label class="custom-control-label" for="<% pageData.houses[i].house_id %>" onclick="handleActivation(event, <%= pageData.houses[i].house_id %>);">وضعیت: <span class="house-status">غیرفعال</span></label>
                      <% } %>
                    </div>
                  </div>
                </div>
              </div>
            <% } %>
          </div>
        </div>
      </div>
    </section>

    <%- include("partials/footer") %>

    <script>
      var activeChat = 0;

      setInterval(function () {
        console.log("UPDATE INTERVAL CALLED");

        var chatHistory = $(".chat-history");
        var messageTemp = ``;
        var lastOrder = 0;

        if (activeChat != 0) {
          if (chatHistory.children().length > 0) {
            lastOrder = parseInt(chatHistory.children().last().attr("messageorder"));
          }

          $.ajax({
            method: "POST",
            url: "/checkmessages",
            dataType: "json",
            data: {
              chat_id: activeChat,
              last_order: lastOrder
            },

            success: function (data) {
              console.log("CHECK MESSAGES REQUEST SUCCESSFUL");
              console.log(data);

              if (data.messages.length > 0) {
                for (i = 0; i < data.messages.length; i++) {
                    if (data.chat.messages[i].sender == userId) {
                      messageTemp = `<div class="chat-message-parent w-100 my-1" messageorder="${data.chat.messages[i].order}"><div class="chat-message p-1 rounded text-right float-left"><h6 class="m-0">${data.chat.messages[i].text}</h6><p class="text-muted small m-0">${data.chat.messages[i].time.toString().slice(16, 21)}</p></div><div class="clearfix"></div></div>`
                      chatHistory.append(messageTemp)
                    } else {
                      messageTemp = `<div class="chat-message-parent chat-me-message-parent w-100 my-1" messageorder="${data.chat.messages[i].order}"><div class="chat-message p-1 rounded text-right"><h6 class="m-0">${data.chat.messages[i].text}</h6><p class="m-0 text-muted small">${data.chat.messages[i].time.toString().slice(16, 21)}</p></div></div>`
                      chatHistory.append(messageTemp)
                    }

                  messageTemp = ``;
                }
              }
            },

            error: function (err) {
              console.log("CHECK MESSAGES REQUEST ERROR");
              console.log(err);
            }
          })
        }

      }, 1000 * 60 * 5)

      function openChatModal (e, userId) {
        var chatTitle = $(".chat-modal-title h5");
        var chatImg = $(".chat-modal-title img");
        var chatHistory = $(".chat-history");
        var messageTemp = ``;

        chatHistory.empty();

        $.ajax({
          method: "POST",
          url: "/getchat",
          dataType: "json",
          data: {
            receiver_id: userId
          },

          success: function (data) {
            console.log("GET CHAT POST REQUEST SUCCESSFUL");
            console.log(data);

            for (i = 0; i < data.chat.messages.length; i++) {
              if (data.chat.messages[i].sender == userId) {
                messageTemp = `<div class="chat-message-parent w-100 my-1" messageorder="${data.chat.messages[i].order}"><div class="chat-message p-1 rounded text-right float-left"><h6 class="m-0">${data.chat.messages[i].text}</h6><p class="text-muted small m-0">${data.chat.messages[i].time.toString().slice(16, 21)}</p></div><div class="clearfix"></div></div>`
                chatHistory.append(messageTemp)
              } else {
                messageTemp = `<div class="chat-message-parent chat-me-message-parent w-100 my-1" messageorder="${data.chat.messages[i].order}"><div class="chat-message p-1 rounded text-right"><h6 class="m-0">${data.chat.messages[i].text}</h6><p class="m-0 text-muted small">${data.chat.messages[i].time.toString().slice(16, 21)}</p></div></div>`
                chatHistory.append(messageTemp)
              }

              messageTemp = ``;
            }

            activeChatUser = userId;
            activeChat = data.chat.chat_id;
          },

          error: function (err) {
            console.log("GET CHAT POST REQUEST ERROR");
            console.log(err);
          }
        })

        $("#chatModal").modal("show");
      }

      $("chatModal").on("hide.bs.modal", function (e) {
        console.log("MODAL CLosing");
        activeChat = 0;
      })

      function sendMessage (e) {
        console.log("SEND MESSAGE CALLED");

        e.preventDefault();

        var chatHistory = $(".chat-history");
        var chatInput = $(".chat-form input");
        var messageTemp = ``;

        $.ajax({
          method: "POST",
          url: "/sendmessage",
          dataType: "json",
          data: {
            chat_id: activeChat,
            text: chatInput.val()
          },

          success: function (data) {
            console.log("SEND MESSAGE POST REQUEST SUCCESSFUL");
            console.log(data);

            messageTemp = `<div class="chat-message-parent chat-me-message-parent w-100 my-1" messageorder="${data.messageOrder}"><div class="chat-message p-1 rounded text-right"><h6 class="m-0">${chatInput.val()}</h6><p class="m-0 text-muted small">${Date().toString().slice(16, 21)}</p></div></div>`

            chatHistory.append(messageTemp)

            messageTemp = ``;

            chatInput.val("");
          },

          error: function (err) {
            console.log("SEND MESSAGE POST REQUEST ERROR");
            console.log(err);
          }
        })
      }

      function handleRequest (e, id, action) {
        console.log("HANDLE REQUEST CALLED");

        var houseDiv = $("div[reserveid='" + id + "']");

        $.ajax({
          method: "POST",
          url: "/handlerequest",
          dataType: "json",
          data: {
            reserve_id: id,
            action: action
          },

          success: function (data) {
            console.log("HANDLE REQUEST POST SUCCESSFUL");
            console.log(data);

            if (action == "accept") {
              houseDiv.children(".card-body").children(".btn-success").remove();
              houseDiv.children(".card-body").children(".btn-danger").remove();
              houseDiv.children(".card-body").children("p .request-status").text("قبول شده");
            } else {
              houseDiv.children(".card-body").children(".send-message-to-guest").remove();
              houseDiv.children(".card-body").children(".btn-success").remove();
              houseDiv.children(".card-body").children(".btn-danger").remove();
              houseDiv.children(".card-body").children("p .request-status").text("رد شده");
            }
          },

          error: function (err) {
            console.log("HANDLE REQUEST POST ERROR");
            console.log(err);
          }
        })
      }

      function handleActivation (e, id) {
        console.log("HANDLE ACTIVATION CALLED");

        var checkInput = $("#" + id);
        var action;

        if (checkInput.prop("checked")) {
          action = "deactivate"
        } else {
          action = "activate"
        }

        $.ajax({
          method: "POST",
          url: "/houseactivation",
          dataType: "json",
          data: {
            house_id: id,
            action: action
          },

          success: function (data) {
            console.log("HANDLE ACTIVATION POST REQUEST SUCCESSFUL");
            console.log(data);

            if (action == "activate") {
              $("label[for='" + id + "']").children(".house-status").text("فعال");
            } else {
              $("label[for='" + id + "']").children(".house-status").text("غیرفعال");
            }
            $("label[for='" + id + "']").click();
          },

          error: function (err) {
            console.log("HANDLE ACTIVATION POST REQUEST ERROR");
            console.log(err);
          }
        })
      }
    </script>

  </body>
</html>
